#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>
#define	LEN	32

int next(FILE *,char *);
int main(int argc,char **argv) {
  char to[14];
  char from[14];
  char buf[LEN+1];
  int addr=0;
  int chk,i,len;
  FILE *fp1,*fp2;

  if (argc!=3) {
    printf("usage: ./text2hex.run file.com file.hex\n");
  } else {
    strcpy(from,argv[1]);
    if ((fp1=fopen(from,"rb"))==NULL) {
      printf("text2hex: Source file %s not found\n", from);
    } else {
      strcpy(to,argv[2]);
      if ((fp2=fopen(to,"w"))==NULL) {
        printf("text2hex: Could not create destination file %s\n", to);
  	  } else {
        while ((len=next(fp1,buf))!=EOF) {
      	  if (len) {
	          fprintf(fp2,":%02X%04X00",len,addr);
	          chk=0;
	          chk-=len;
	          chk-=addr&0xff;
	          chk-=addr>>8;
	          for (i=0;i<len;i++) {
	            fprintf(fp2,"%02X",buf[i]&0xff);
	            chk-=buf[i]&0xff;
	          }
	          fprintf(fp2,"%02X\n",chk & 0xff);
	        }
	        addr+=LEN;
	      }
        fprintf(fp2,":00000001FF\n");
        fclose(fp1);
        fclose(fp2);
        printf("Addr=%04X, Saved %d %s\n",addr,(addr>>8)+1,argv[1]);
      }
    }
  }
  return 0;
}

int next(FILE *fp1,char *buf){
  int i,ch,flag = 1;

  for (i=0;i<LEN;i++) {
	  ch=fgetc(fp1);
	  if (ch==EOF) return EOF;
	  if (ch>0) flag=0;
    buf[i]=ch;
  }
  if (flag) return 0;
  return LEN;
}

